/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fel.cvut.pjv;

import java.util.ArrayList;
import java.util.List;

public class Car implements BicycleVisitor{
    private List<BicycleHolder> carHolders = new ArrayList<>(4);

    
    private void addHolder(BicycleHolder holder) {
        if (carHolders.size() < 4) {
            carHolders.add(holder);
        } else {
            throw new IndexOutOfBoundsException();
        }
    }

    public void print() {
        for (BicycleHolder holder : carHolders) {
            System.out.println(holder.getClass().getSimpleName() + " holding "
                    + holder.getBike().getClass().getSimpleName());
        }

    }
    
    @Override
    public void accept(Bicycle bike) {
        addHolder(new BicycleHolder(bike));
    }

    @Override
    public void accept(MountainBike bike) {
        addHolder(new MountainBikeHolder(bike));
    }

    @Override
    public void accept(RoadBike bike) {
        addHolder(new RoadBikeHolder(bike));
    }
    
}
