package cz.fel.cvut.pjv;


import cz.fel.cvut.pjv.Bicycle;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


/**
 *
 * @author mudromar
 */
public class TestBikes {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Bicycle bike01, bike02, bike03;

        bike01 = new Bicycle(20, 10, 1);
        bike02 = new MountainBike(20, 10, 5, "Dual");
        bike03 = new RoadBike(40, 20, 8, 23);

        bike01.printDescription();
        bike02.printDescription();
        bike03.printDescription();
        
        BasicService service1 = new BasicService();
        BasicService service2 = new MountainBikeService();
        BasicService service3 = new RoadBikeService();
        
        System.out.println("\nSingle dispatch:");
        service1.accept(bike01);
        service2.accept(bike02);
        service3.accept(bike03);
        
        System.out.println("\nDouble dispatch:");
        bike01.visit(service1);
        bike02.visit(service1);
        bike03.visit(service1);
        System.out.println("-");
        bike01.visit(service2);
        bike02.visit(service2);
        bike03.visit(service2);
        System.out.println("-");
        bike01.visit(service3);
        bike02.visit(service3);
        bike03.visit(service3);
        
        System.out.println("\nSingle dispatch:");
        Car car = new Car();
        car.accept(bike01);
        car.accept(bike02);
        car.accept(bike03);
        car.print();
        
        System.out.println("\nDouble dispatch:");
        car = new Car();
        bike01.visit(car);
        bike02.visit(car);
        bike03.visit(car);
        car.print();
        
        
        
        
        
        
        
        
        
        
        
        
        
        

//        BasicService service1 = new BasicService();
//        BasicService service2 = new MountainBikeService();
//        BasicService service3 = new RoadBikeService();
//
//        System.out.println("\nSingle dispatch:");
//        service1.accept(bike01);
//        service2.accept(bike02);
//        service3.accept(bike03);
//        
//        System.out.println("\nDouble dispatch:");
//        bike01.visit(service1);
//        bike02.visit(service2);
//        bike03.visit(service3);
//        
//        System.out.println("\nSingle dispatch:");
//        Car car = new Car();
//        car.accept(bike01);
//        car.accept(bike02);
//        car.accept(bike03);
//        car.print();
    }

}
